"""
    Diff

A named tuple representing a difference of added and removed nodes and edges on a [`DAG`](@ref).
"""
const Diff = NamedTuple{
    (:addedNodes, :removedNodes, :addedEdges, :removedEdges, :updatedChildren),
    Tuple{Vector{Node}, Vector{Node}, Vector{Edge}, Vector{Edge}, Vector{Tuple{Node, Symbol, Symbol}}},
}

function Diff()
    return (
        addedNodes = Vector{Node}(),
        removedNodes = Vector{Node}(),
        addedEdges = Vector{Edge}(),
        removedEdges = Vector{Edge}(),

        # children were updated from updatedChildren[2] to updatedChildren[3] in node updatedChildren[1]
        updatedChildren = Vector{Tuple{Node, Symbol, Symbol}}(),
    )::Diff
end
